//----------------------------------------------------------------------------------
//
// Morse paddle project using D2F microswitches, version 4 - large
// Part: Cover
// (c) 2019 Jan Uhrin, OM2JU
//
//
$fn = 64;    // Rounding parameter; for production set to high (e.g. 40) 
//
//----------------------------------------------------------------------------------
//
// Rounded primitives for openscad
// (c) 2013 Wouter Robers 

// Syntax example for a rounded block
//translate([-15,0,10]) rcube([20,20,20],2);

// Syntax example for a rounded cylinder
//translate([15,0,10]) rcylinder(r1=15,r2=10,h=20,b=2);

module rcube(Size=[20,20,20],b=2)
{hull(){for(x=[-(Size[0]/2-b),(Size[0]/2-b)]){for(y=[-(Size[1]/2-b),(Size[1]/2-b)]){for(z=[-(Size[2]/2-b),(Size[2]/2-b)]){ translate([x,y,z]) sphere(b);}}}}}


module rcylinder(r1=10,r2=10,h=10,b=2)
{translate([0,0,-h/2]) hull(){rotate_extrude() translate([r1-b,b,0]) circle(r = b); rotate_extrude() translate([r2-b, h-b, 0]) circle(r = b);}}
    
//----------------------------------------------------------------------------------

difference() {
// difference of two rounded cubes, creates shell like object
translate([0,0,30/2])     rcube(Size=[10+28+3.6+8-6,15+52+2.6,30],b=10);
translate([0,0,50/2+1.6]) rcube(Size=[10+28-1.6+8-6,15+52,50],b=10);  

// big cube from top to limit height
translate([0,0,10+85]) cube(size=[150,150,150],center=true);  

// front side opening for paddles
translate([0,25,12.0]) rcube(Size=[16.4,23,13],b=2.0);  
rotate([0,90,90]) translate([-8.4,5.4,30.0]) cylinder(h=10,r1=6.8,r2=6.8,center=true);  
rotate([0,90,90]) translate([-8.4,-5.4,30.0]) cylinder(h=10,r1=6.8,r2=6.8,center=true);  

// rear side hole jack
translate([0,-35,13.0]) rcube(Size=[10.6,15,10.6],b=4);  


// cut from inside as guide for base plate which will be inserted
translate([0,0,17.4])   cube(size=[38+8.4-6,58,2],center=true);

//
rotate([0,180,90])
    translate([ -20.0,-6.0,4.0]) linear_extrude (height=10, center = true) text("WWFF", size=13.0, font="Courier:style=Bold");


translate([130.4,4,10])
cylinder(h = 30, r1 = 110.0, r2 = 110.0, center = true, $fn = 256);

translate([101,4,10])
cylinder(h = 30, r1 = 88, r2 = 74, center = true, $fn = 256);

translate([-130.4,4,10])
cylinder(h = 30, r1 = 110.0, r2 = 110.0, center = true, $fn = 256);

translate([-101,4,10])
cylinder(h = 30, r1 = 88, r2 = 74, center = true, $fn = 256);


}



